## Copyright (C) 2018 John Donoghue <john.donoghue@ieee.org>
## 
## This program is free software: you can redistribute it and/or modify it
## under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful, but
## WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see
## <https://www.gnu.org/licenses/>.

% example using the arduino stuff
pkg load instrument-control

%n = __arduino_binary__ ()

a = arduino("/dev/ttyACM0");

getMCU(a)

printf("try spi\n");

#spi = spidev(a, "d1")


printf("try spi done\n");


validatePin(a, "a0", "digital")
terminal = getTerminalsFromPins(a, "a0")
terminal2 = getTerminalsFromPins(a, { "a0" "d1" })
owner = getResourceOwner(a, terminal) 
#
#configurePinResource(a, "d11")
#printf("x\n");
#configurePinResource(a, "d11", "johnd", "digital")
#configurePinResource(a, "d11")

%validatePin(a, "D11", "Digital");
configurePin(a,'D2')

%configurePin(a, "D11")
#configurePin(a, "D2", "digitaloutput")
#configurePin(a,'D2')

printf("clearing ....\n");
configurePin(a, "D2", "unset")
# shpuld fail as already set now
printf("setting ....\n");
#configurePin(a, "D2", "digitalinput")
#configurePin(a, "D2", "digitalinput")

#configurePin(a, "D2")

printf("setting A0...");
configurePin(a, "A0", "analoginput");
configurePin(a, "A0")
owner = getResourceOwner(a, "A0") 

#sendCommand(a, "", 44, [], 10)
mode = getTerminalMode(a, 14)
dig = isTerminalDigital(a, 14)
ana = isTerminalAnalog(a, 14)
dig = isTerminalDigital(a, 2)
ana = isTerminalAnalog(a, 2)
terms = getPWMTerminals(a)

while (true)
  writeDigitalPin(a, 'D2', 0);
  pause(0.5);
  volts = readVoltage(a, "A0")
  in = readDigitalPin(a, "D2")
  writeDigitalPin(a, 'D2', 1);
  writePWMDutyCycle(a, 'D3', 1);
  pause(0.5);
  raw = readAnalogPin(a, "A0")
  volts = readVoltage(a, "A0")
  in = readDigitalPin(a, "D2")
  writePWMDutyCycle(a, 'D3', 0.5);
endwhile

clear a
